/*
 * @Author: fxs bjnsfxs@163.com
 * @Date: 2024-08-23 14:58:29
 * @LastEditors: fxs bjnsfxs@163.com
 * @LastEditTime: 2024-08-28 16:16:44
 * @FilePath: \Game-Backstage-Management-System\src\types\dataAnalysis.ts
 * @Description:用于dataAnalysis相关组件的type
 *
 */

// 下拉选项的信息
export interface DropDownItem {
  value: any
  label: string
}

// 下拉框所需要的props信息
export interface DropDownInfo {
  size?: string
  defaultSelect: any
  title: string
  optionsList: Array<DropDownItem>
}

/**
 * @description: 数据展示组件的请求配置
 *
 * @return {*}
 */
export interface StaticReqConfig {
  url: string
  otherOptions: any
}

// 数据展示的字段信息
export interface StaticField {
  name: string
  cnName: string
  value: any // 值
  compareVal?: any
}

// 数据分析页面头部数据所需要的props
// 其中如果配置了请求参数，那么会使用url去查询，然后赋值
// 如果没有则直接使用fieldinfo里的value
export interface StaticDataInfo {
  requestConfig?: StaticReqConfig // 请求参数配置
  fieldsInfo: Array<StaticField> //字段信息
  titleClass?: string // 标题的样式
  valueClass?: string // 值的样式
}

// 时间趋势图的tab信息
export interface TabInfo {
  name: string // tab的字段
  tabTitle: string // tab的标题
  type: number // 到时候需要获取数据的url
}

/**
 * @description: 图表所需要的props,其中的legnedData毓seriesData的length要一致
 *              series中的name依赖毓lengdata
 * @return {*}
 */
export interface OptionsProps {
  xAxisData: Array<any> // x轴的刻度lable
  legendData: Array<any> // 图例的信息
  seriesData: Array<any> // 数据
}

// 时间趋势组件所需要的props
export interface TemporalTrendProps {
  type: number // 趋势组件的类型，1为小时段，2为日期统计
  tabInfo: Array<TabInfo> // 用于切换的tab的信息
  requestConfig: StaticReqConfig // 请求参数配置，需要监听，一旦变化，需要重新获取数据
  defaultActive: string // 默认选中的tab
  title: string // 上方显示的title
}

// 头部切换组件所需要的props
export interface HeaderCardProps {
  title: string // title信息
  defaultPf?: string // 默认选择的pf
  openDateSelect: boolean // 是否开启时间选择
}
