// 颜色类型
export enum ColorType {
  DEFAULT = 'default',
  PRIMARY = 'primary',
  SUCCESS = 'success',
  INFO = 'info',
  WARNING = 'warning',
  DANGER = 'danger'
}

export interface GameTableData {
  gameName: string //游戏名称
  gid: string //游戏ID
  ttAppid: string //游戏 tt 平台id
  ttSecret: string //游戏 tt 平台密钥
  wxAppid: string //游戏 微信平台 id
  wxSecret: string // 游戏 微信 平台密钥
}

// 表格分页的数据类型
export interface TablePaginationSetting {
  limit: number // 每页展示个数
  currentPage: number // 当前页码
  total: number // 数据总数
  pagesizeList: Array<number> // 页数大小列表
  loading: boolean // 加载图标
  hasLodingData: number // 已经加载的数据
}

// 表格信息过滤时，需要用到的过滤类型
export enum FilterType {
  INPUT = 'input',
  SELECT = 'select',
  DATE = 'date'
}

// 筛选信息的格式
export interface QueryInfo {
  name: string
  label: string
  type: FilterType
  placeholder: string
  otherOption?: any
  default?: any
}

// 字段特殊效果类型
export enum FieldSpecialEffectType {
  IMG = 'img',
  TAG = 'tag',
  TEXT = 'text',
  TRANSLATE = 'translate'
}

// 表格字段信息格式
export interface TableFieldInfo {
  name: string
  cnName: string
  isShow: boolean
  specialEffect?: {
    type: FieldSpecialEffectType
    othnerInfo?: any
    color?: Array<ColorType>
  }
}

// props的参数格式
export interface PropsParams {
  needRowindex: boolean // 是否需要行号
  needAverage: boolean // 是否需要均值功能
  needLeftTools: boolean // 是否需要左侧的工具栏
  needRightTools: boolean // 是否需要右侧工具栏
  openFilterQuery: boolean // 是否开启上方查询功能
  openPageQuery: boolean // 是否开启分页查询
  dataList?: Array<any> // 表格数据，可以直接传入，也可以给请求地址来请求
  queryInfo?: Array<QueryInfo> // 上方查询功能所需要的信息
  paginationConfig: TablePaginationSetting // 表格分页的信息
  tableFieldsInfo: Array<TableFieldInfo> // 表格字段信息
  requestConfig?: {
    // 表格请求的配置
    url: string
    other: any
  }
}

// 选择下拉框的信息格式
export interface SelectInfo {
  name: string
  cnName: string
  value: any
}

// 对话框设置
export interface DialogSetting {
  dialogVisible: boolean
  title: string
  formLabelWidth: string
  type: number // 0 是新增 1是修改
}
